package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.pojo.ConsultInfo;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryList;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryOne;
import org.jfw.util.PageQueryResult;

import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * Created by TT on 2017/5/3.
 */
@DAO
public abstract class ConsultDao {

    @QueryList
    @OrderBy("ORDER BY CREATE_TIME DESC")
    public abstract List<ConsultInfo> query(Connection con) throws SQLException;

    public PageQueryResult<ConsultInfo> pageQuery(Connection con, String consultantName, String professorName, String consultTitle, Integer consultStatus, int pageSize, int pageNo) throws SQLException {
        int index = 0;
        PageQueryResult<ConsultInfo> queryResult = new PageQueryResult<ConsultInfo>();
        int paramIndex = 1;
        boolean b1 = null == consultStatus;
        StringBuilder sql = new StringBuilder();
        sql.append(" WHERE consultant_name LIKE ? AND professor_name LIKE ? AND consult_title LIKE ? ");
        if (!b1) {
            sql.append(" AND consult_status = ?");
        }
        StringBuilder sbql = sql;
        sql = new StringBuilder();
        sql.append(" select count(1) from (SELECT p.name as professor_name,o.name as professor_org,pp.name as consultant_name,oo.name as consultant_org,c.CONSULT_ID,c.CONSULT_TYPE,c.CONSULT_TITLE,c.CONSULT_CONTANT,c.PROFESSOR_ID,c.CONSULTANT_ID,c.CONSULT_STATUS,c.FINISH_TIME,c.ASSESS_STATUS,c.ASSESS_STAR,c.ASSESS_CONTANT,c.ASSESS_TIME,c.THANKS_STATUS,c.THANKS_MONEY,c.THANKS_TIME,c.REVOVERY_TIME,c.READ_STATUS,c.DEMAND_ID,c.CREATE_TIME FROM consult c LEFT JOIN professor p on c.professor_id = p.id LEFT JOIN professor pp on c.consultant_id = pp.id LEFT JOIN organization o on o.id = p.org_id LEFT JOIN organization oo on oo.id = pp.org_id ORDER BY CREATE_TIME DESC)as view_consult ");
        sql.append(sbql);
        PreparedStatement ps = con.prepareStatement(sql.toString());
        try {
            ps.setString(paramIndex++, consultantName);
            ps.setString(paramIndex++, professorName);
            ps.setString(paramIndex++, consultTitle);
            if (!b1) {
                ps.setInt(paramIndex++, consultStatus);
            }
            queryResult.setPageSize(pageSize);
            ResultSet resultSet = ps.executeQuery();
            try {
                resultSet.next();
                index = resultSet.getInt(1);
            } finally {
                try {
                    resultSet.close();
                } catch (Exception e) {
                }
            }
        } finally {
            try {
                ps.close();
            } catch (Exception e) {
            }
        }
        queryResult.setTotal(index);
        if (0 == index) {
            queryResult.setPageNo(1);
            queryResult.setData(Collections.<ConsultInfo>emptyList());
            return queryResult;
        }
        paramIndex = 1;
        boolean b2 = (1 == pageNo);
        if (b2) {
            queryResult.setPageNo(1);
            sql = new StringBuilder();
            sql.append(" WHERE pp.name LIKE ? AND p.name LIKE ? AND c.consult_title LIKE ? ");
            if (!b1) {
                sql.append(" AND c.consult_status = ?");
            }
            StringBuilder stringBuilder = sql;
            sql = new StringBuilder();
            sql.append(" SELECT p.name as professor_name,o.name as professor_Org,pp.name as consultant_Name,oo.name as consultant_Org,c.CONSULT_ID,c.CONSULT_TYPE,c.CONSULT_TITLE,c.CONSULT_CONTANT,c.PROFESSOR_ID,c.CONSULTANT_ID,c.CONSULT_STATUS,c.FINISH_TIME,c.ASSESS_STATUS,c.ASSESS_STAR,c.ASSESS_CONTANT,c.ASSESS_TIME,c.THANKS_STATUS,c.THANKS_MONEY,c.THANKS_TIME,c.REVOVERY_TIME,c.READ_STATUS,c.DEMAND_ID,c.CREATE_TIME FROM consult c LEFT JOIN professor p on c.professor_id = p.id LEFT JOIN professor pp on c.consultant_id = pp.id LEFT JOIN organization o on o.id = p.org_id LEFT JOIN organization oo on oo.id = pp.org_id ");
            sql.append(stringBuilder);
            sql.append(" ORDER BY CREATE_TIME DESC ");
            sql.append(" LIMIT ").append(pageSize);
        } else {
            int pno = index / pageSize;
            if (index % pageSize != 0) {
                ++pno;
            }
            if (pageNo > pno) {
                pageNo = pno;
            }
            queryResult.setPageNo(pageNo);
            --pageNo;
            int offset = (pageNo * pageSize);
            sql = new StringBuilder();
            sql.append(" WHERE pp.name LIKE ? AND p.name LIKE ? AND c.consult_title LIKE ? ");
            if (!b1) {
                sql.append(" AND c.consult_status = ?");
            }
            StringBuilder stringBuilder = sql;
            sql = new StringBuilder();
            sql.append(" SELECT p.name as professor_name,o.name as professor_Org,pp.name as consultant_Name,oo.name as consultant_Org,c.CONSULT_ID,c.CONSULT_TYPE,c.CONSULT_TITLE,c.CONSULT_CONTANT,c.PROFESSOR_ID,c.CONSULTANT_ID,c.CONSULT_STATUS,c.FINISH_TIME,c.ASSESS_STATUS,c.ASSESS_STAR,c.ASSESS_CONTANT,c.ASSESS_TIME,c.THANKS_STATUS,c.THANKS_MONEY,c.THANKS_TIME,c.REVOVERY_TIME,c.READ_STATUS,c.DEMAND_ID,c.CREATE_TIME FROM consult c LEFT JOIN professor p on c.professor_id = p.id LEFT JOIN professor pp on c.consultant_id = pp.id LEFT JOIN organization o on o.id = p.org_id LEFT JOIN organization oo on oo.id = pp.org_id ");
            sql.append(stringBuilder);
            sql.append(" ORDER BY CREATE_TIME DESC ");
            sql.append(" LIMIT ").append(pageSize).append(" OFFSET ").append(offset);
        }
        ps = con.prepareStatement(sql.toString());
        try {
            ps.setString(paramIndex++, consultantName);
            ps.setString(paramIndex++, professorName);
            ps.setString(paramIndex++, consultTitle);
            if (!b1) {
                ps.setInt(paramIndex++, consultStatus);
            }
            ResultSet rs = ps.executeQuery();
            try {
                List<ConsultInfo> consultInfos = new ArrayList<ConsultInfo>();
                queryResult.setData(consultInfos);
                int indx = 0;
                while ((indx < pageSize) && rs.next()) {
                    ++indx;
                    ConsultInfo consultInfo = new ConsultInfo();
                    String pName = rs.getString(1);
                    if (rs.wasNull()) {
                        pName = null;
                    }
                    consultInfo.setProfessorName(pName);
                    String pOrg = rs.getString(2);
                    if (rs.wasNull()) {
                        pOrg = null;
                    }
                    consultInfo.setProfessorOrg(pOrg);
                    String cName = rs.getString(3);
                    if (rs.wasNull()) {
                        cName = null;
                    }
                    consultInfo.setConsultantName(cName);
                    String cOrg = rs.getString(4);
                    if (rs.wasNull()) {
                        cOrg = null;
                    }
                    consultInfo.setConsultantOrg(cOrg);
                    String cId = rs.getString(5);
                    if (rs.wasNull()) {
                        cId = null;
                    }
                    consultInfo.setConsultId(cId);
                    String consultType = rs.getString(6);
                    if (rs.wasNull()) {
                        consultType = null;
                    }
                    consultInfo.setConsultType(consultType);
                    String cTitle = rs.getString(7);
                    if (rs.wasNull()) {
                        cTitle = null;
                    }
                    consultInfo.setConsultTitle(cTitle);
                    String consultContant = rs.getString(8);
                    if (rs.wasNull()) {
                        consultContant = null;
                    }
                    consultInfo.setConsultContant(consultContant);
                    String pId = rs.getString(9);
                    if (rs.wasNull()) {
                        pId = null;
                    }
                    consultInfo.setProfessorId(pId);
                    String consultantId = rs.getString(10);
                    if (rs.wasNull()) {
                        consultantId = null;
                    }
                    consultInfo.setConsultantId(consultantId);
                    Integer cStatus = rs.getInt(11);
                    if (rs.wasNull()) {
                        cStatus = null;
                    }
                    consultInfo.setConsultStatus(cStatus);
                    String finishTime = rs.getString(12);
                    if (rs.wasNull()) {
                        finishTime = null;
                    }
                    consultInfo.setFinishTime(finishTime);
                    Integer assessStatus = rs.getInt(13);
                    if (rs.wasNull()) {
                        assessStatus = null;
                    }
                    consultInfo.setAssessStatus(assessStatus);
                    Integer assessStar = rs.getInt(14);
                    if (rs.wasNull()) {
                        assessStar = null;
                    }
                    consultInfo.setAssessStar(assessStar);
                    String assessContant = rs.getString(15);
                    if (rs.wasNull()) {
                        assessContant = null;
                    }
                    consultInfo.setAssessContant(assessContant);
                    String assessTime = rs.getString(16);
                    if (rs.wasNull()) {
                        assessTime = null;
                    }
                    consultInfo.setAssessTime(assessTime);
                    Integer thanksStatus = rs.getInt(17);
                    if (rs.wasNull()) {
                        thanksStatus = null;
                    }
                    consultInfo.setThanksStatus(thanksStatus);
                    BigDecimal thanksMoney = rs.getBigDecimal(18);
                    if (rs.wasNull()) {
                        thanksMoney = null;
                    }
                    consultInfo.setThanksMoney(thanksMoney);
                    String thanksTime = rs.getString(19);
                    if (rs.wasNull()) {
                        thanksTime = null;
                    }
                    consultInfo.setThanksTime(thanksTime);
                    consultInfo.setRevoveryTime(rs.getString(20));
                    consultInfo.setReadStatus(rs.getInt(21));
                    String demandId = rs.getString(22);
                    if (rs.wasNull()) {
                        demandId = null;
                    }
                    consultInfo.setDemandId(demandId);
                    consultInfo.setCreateTime(rs.getString(23));
                    consultInfos.add(consultInfo);
                }
                return queryResult;
            } finally {
                try {
                    rs.close();
                } catch (Exception e) {
                }
            }
        } finally {
            try {
                ps.close();
            } catch (Exception e) {
            }
        }
    }

    @Nullable
    @QueryOne
    public abstract ConsultInfo query(Connection con, String consultId) throws SQLException;
}
